	function _print(font, x, y, color, text)
		font:activate();
		font:print(x,y,color,text);
	end
	
	function drawmap(map)
		map:activate()
		map:draweasy(0, 0)
	end

	function drawsmap(map,x,y)
		map:activate()
		map:draweasy(x, y)
	end

	function drawhero() 
		
		u0 = (spriteoffset + animframe) * SPRITEDIM
		u1 = SPRITEDIM
		v0 = 0
		v1 = SPRITEDIM
		
		if direction == LEFT then
			u0 = (spriteoffset + animframe + 1) * SPRITEDIM
			u1 = 0 - SPRITEDIM
		end
		
		ash:activate()
		ash:draw(xpos, ypos, SPRITEDIM, SPRITEDIM, u0, v0, u1, v1)
	end

	function animatehero()
	
		moving = false
	
		if pge.controls.held(PGE_CTRL_LEFT) or pge.controls.analogx() < -64 then
			direction = LEFT
			spriteoffset = SPRITEWALKLEFT
			xpos = xpos - walkspeed
			moving = true
		elseif pge.controls.held(PGE_CTRL_RIGHT) or pge.controls.analogx() > 64 then
			direction = RIGHT
			spriteoffset = SPRITEWALKRIGHT
			xpos = xpos + walkspeed
			moving = true
		elseif pge.controls.held(PGE_CTRL_UP) or pge.controls.analogy() < -64 then
			direction = UP
			spriteoffset = SPRITEWALKUP
			ypos = ypos - walkspeed
			moving = true
		elseif pge.controls.held(PGE_CTRL_DOWN) or pge.controls.analogy() > 64 then
			direction = DOWN
			spriteoffset = SPRITEWALKDOWN
			ypos = ypos + walkspeed
			moving = true
		end
		
		if moving == true then
			animwait = animwait - 1
			
			if animwait <= 0 then
				animwait = ANIMWAIT
				animframe = animframe + 1
				
				if animframe >= ANIMFRAMES then
					animframe = 0
				end
			end
			
		else
			
			animframe = 0
			
			if direction == UP then
				spriteoffset = SPRITESTANDUP
			elseif direction == DOWN then
				spriteoffset = SPRITESTANDDOWN
			elseif direction == LEFT then
				spriteoffset = SPRITESTANDLEFT
			elseif direction == RIGHT then
				spriteoffset = SPRITESTANDRIGHT
			else
				spriteoffset = SPRITESTANDUP
			end
		end
	end

	function endMainFunctions()
		pge.gfx.enddrawing();
		pge.gfx.swapbuffers();
	end
	
	function loadgame()
	 
		enabled = true
		state = -1
		carregado = false
		
		if not pge.utils.loadinit(50, "PSPOKEMON") then
			error("Error on load dialog init.")
		end
		
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			--drawmap(savebg)
			pge.gfx.enddrawing()
			
			if enabled then
				state, dados = pge.utils.savedataupdate()
			 
				if state == 0 then
					carregado = true
					run = true
				elseif state == 1 then
					enabled = false
					break
				elseif state ~= PGE_UTILS_DIALOG_RUNNING then
					enabled = false
					break
				end
			end
			
			pge.gfx.swapbuffers()
			
			if carregado then
				exclmarkpos = string.find(dados, "!")
				quesmarkpos = string.find(dados, "?")
				forwslashpos = string.find(dados, "/")
				thingypos = string.find(dados, "@")
				vertslashpos = string.find(dados, "|")
			 
				xpos = tonumber(dados:sub(1,exclmarkpos - 1))
				ypos = tonumber(dados:sub(exclmarkpos + 1, quesmarkpos - 1))
				zone = tonumber(dados:sub(quesmarkpos + 1, forwslashpos - 1))
				victories = tonumber(dados:sub(forwslashpos + 1, thingypos - 1))
				potions = tonumber(dados:sub(thingypos + 1, vertslashpos - 1))
				if string.find(dados, "#") ~= nil then
					gridsignpos = string.find(dados, "#")
					wildcardpos = string.find(dados, "*")
					andamppos = string.find(dados, "&")
					
					money = tonumber(dados:sub(vertslashpos + 1, gridsignpos - 1))
					mp = tonumber(dados:sub(gridsignpos + 1, wildcardpos - 1))
					shpr = tonumber(dados:sub(wildcardpos + 1, andamppos - 1))
					sxpr = tonumber(dados:sub(andamppos + 1))
				else
					money = tonumber(dados:sub(vertslashpos + 1))
				end
				
				if zone == 3 then
					zone = casa
				elseif zone == 4 then
					zone = casa1
				elseif zone == 5 then
					zone = casa2
				elseif zone == 6 then
					zone = gym
				elseif zone == 7 then
					zone = lab
				end
				
				if mp == 1 then
					mypokemon = serpifeu
				elseif mp == 2 then
					mypokemon = floink
				elseif mp == 3 then
					mypokemon = ottaro
				end
				
				break
			end
			
		end
		state = nil
		enabled = nil
		dados = nil
	end
	
	function getpokemon()
		local menuSelector = 0
		
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()
			drawsmap(pokemenu,120, 71);
			_print(trebuc12,135,150,white,l10n.texttype);
			_print(trebuc12,135,165,white,l10n.texthgt);
			_print(trebuc12,135,180,white,l10n.textwht);
			
			if pge.controls.pressed(PGE_CTRL_LEFT) then
				menuSelector = menuSelector - 1
			elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
				menuSelector = menuSelector + 1
			end
			
			if menuSelector >= 3 then
				menuSelector = 0
			elseif menuSelector < 0 then
				menuSelector = 2
			end
			
			if menuSelector == 0 then
				drawsmap(serpifeu,135, 81);
				_print(trebuc16,235,81,white,"Serpifeu");
				_print(trebuc12,190,150,white,l10n.typegrass);
				_print(trebuc12,190,165,white,"0.6 m");
				_print(trebuc12,190,180,white,"8.1 kg");
			elseif menuSelector == 1 then
				drawsmap(floink,135, 81);
				_print(trebuc16,235,81,white,"Floink");
				_print(trebuc12,190,150,white,l10n.typefire);
				_print(trebuc12,190,165,white,"0.6 m");
				_print(trebuc12,190,180,white,"9.9 kg");
			elseif menuSelector == 2 then
				drawsmap(ottaro,135, 81);
				_print(trebuc16,235,81,white,"Ottaro");
				_print(trebuc12,190,150,white,l10n.typewater);
				_print(trebuc12,190,165,white,"0.5 m");
				_print(trebuc12,190,180,white,"5.9 kg");
			end
			
			if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
				selected = 1
				break
			elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
				selected = 2
				break
			elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
				selected = 3
				break
			end
			
			endMainFunctions();
			
			if pge.controls.pressed(PGE_CTRL_CIRCLE) then
				menuSelector = nil
				break
			end
		end
		
		pge.mp3.pause()
		
		if selected == 1 then
			received:play()
				while pge.running() do
					pge.gfx.startdrawing()
					mypokemon = serpifeu
					drawsmap(dialog,120, 71);
					trebuc16:activate();
					trebuc16:printcenter(120, white, l10n.chooseblub)
					endMainFunctions();
					pge.delay(3000000)
					break
				end
		end
		
		if selected == 2 then
			received:play()
				while pge.running() do
					pge.gfx.startdrawing()
					mypokemon = floink
					drawsmap(dialog,120, 71);
					trebuc16:activate();
					trebuc16:printcenter(120, white, l10n.choosechar)
					endMainFunctions();
					pge.delay(3000000)
					break
				end
		end
		
		if selected == 3 then
			received:play()
				while pge.running() do
					pge.gfx.startdrawing()
					mypokemon = ottaro
					drawsmap(dialog,120, 71);
					trebuc16:activate();
					trebuc16:printcenter(120, white, l10n.choosesquir)
					endMainFunctions();
					pge.delay(3000000)
					break
				end
		end
		
		if selected ~= nil then
			dofile('Content/Scripts/pokemon.lua');
			
			mypoke.hpr = mypoke.hp
			mypoke.xpr = mypoke.xp
		end
		
		pge.mp3.pause()
		
		selected = nil
	end
	
	function secondpass(zone, zonex, zoney)
		pge.gfx.clearscreen(pge.gfx.createcolor(0, 0, 0,0))
		if zone == 1 then
			drawmap(zona1);
			trainer1:activate()
			trainer1:draw(trainer[1].x, trainer[1].y, SPRITEDIM, SPRITEDIM, a, b, c, d)
		elseif zone == 2 then
			drawmap(zona2);
			trainer2:activate()
			trainer2:draw(trainer[2].x, trainer[2].y, SPRITEDIM, SPRITEDIM, a, b, c, d)
		elseif zone == lab then
			drawsmap(zone,zonex,zoney);
			drawsmap(oak, 225, 85);
		elseif zone == gym then
			drawsmap(zone,zonex,zoney);
			if trainer[0].direction == "down" then
				drawsmap(trainer0,trainer[0].x,trainer[0].y)
			elseif trainer[0].direction == "right" then
				drawsmap(trainer0_r,trainer[0].x,trainer[0].y)
			elseif trainer[0].direction == "left" then
				drawsmap(trainer0_l,trainer[0].x,trainer[0].y)
			end
		elseif zone == casa2 then
			drawsmap(zone,zonex,zoney);
			drawsmap(seller, 305, 90);
		elseif zone ~= 1 and zone ~= 2 then
			drawsmap(zone,zonex,zoney);
		end
		drawhero();
	end

	function pausemenu()

		pge.mp3.pause()
		local menuSelector = 0
		
		
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()

			secondpass(zone, zonex, zoney);
			
			drawsmap(pause,365, 0);
			_print(trebuc12,385,15,white,l10n.pauseopt1);
			_print(trebuc12,385,35,white,l10n.pauseopt2);
			_print(trebuc12,385,55,white,l10n.pauseopt3);
			_print(trebuc12,385,75,white,l10n.pauseopt4);
			
			if pge.controls.pressed(PGE_CTRL_UP) then
				menuSelector = menuSelector - 1
			elseif pge.controls.pressed(PGE_CTRL_DOWN) then
				menuSelector = menuSelector + 1
			end
			
			if menuSelector >= 4 then
				menuSelector = 0
			elseif menuSelector < 0 then
				menuSelector = 3
			end
			
			if menuSelector == 0 then
				_print(trebuc12,385,15,blue,l10n.pauseopt1);
			elseif menuSelector == 1 then
				_print(trebuc12,385,35,blue,l10n.pauseopt2);
			elseif menuSelector == 2 then
				_print(trebuc12,385,55,blue,l10n.pauseopt3);
			elseif menuSelector == 3 then
				_print(trebuc12,385,75,blue,l10n.pauseopt4);
			end
			
			if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
				if mypokemon then
				   evolution();
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						drawsmap(dialog,120, 71);
						_print(trebuc12,135,150,white,l10n.textlvl2);
						_print(trebuc12,135,165,white,l10n.texthp2);
						_print(trebuc12,135,180,white,l10n.textxp);
						
						drawsmap(mypokemon,135, 81);
						_print(trebuc16,235,81,white,mypoke.name);
						pge.gfx.drawrect(135, 135, calchp(mypoke), 5, colorhp(mypoke))
						pge.gfx.drawrectoutline(135, 135, 60, 5, white)
						_print(trebuc12,190,150,white,subirnivel());
						_print(trebuc12,190,165,white,mypoke.hpr);
						_print(trebuc12,190,180,white,mypoke.xpr);
						
						_print(trebuc12,235,115,white,l10n.textatks);
						_print(trebuc12,245,135,white,mypoke.atk1);
						_print(trebuc12,245,150,white,mypoke.atk2);
						_print(trebuc12,245,165,white,getattack3());
						_print(trebuc12,245,180,white,getattack4());
						
						endMainFunctions();
						
						if pge.controls.pressed(PGE_CTRL_CIRCLE) then
							break
						end
					end
				else
				end
			elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
			menuSelector = 0
				while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						drawsmap(dialog,120, 71);
						
						drawsmap(bag,135, 81);
						_print(trebuc16,235,81,white,l10n.itens);
						
						_print(trebuc12,135,150,white,l10n.itens1);
						_print(trebuc12,135,165,white,"--");
						_print(trebuc12,135,180,white,"--");
						
						_print(trebuc12,190,150,white,itens.potion);
						
						if pge.controls.pressed(PGE_CTRL_UP) then
							menuSelector = menuSelector - 1
						elseif pge.controls.pressed(PGE_CTRL_DOWN) then
							menuSelector = menuSelector + 1
						end
						
						if menuSelector >= 3 then
							menuSelector = 0
						elseif menuSelector < 0 then
							menuSelector = 2
						end
						
						if menuSelector == 0 then
							_print(trebuc12,135,150,blue,l10n.itens1);
							_print(trebuc12,190,150,blue,itens.potion);
						elseif menuSelector == 1 then
							_print(trebuc12,135,165,blue,"--");
						elseif menuSelector == 2 then
							_print(trebuc12,135,180,blue,"--");
						end
						if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
							usepotion();
						elseif menuSelector ==1 and pge.controls.pressed(PGE_CTRL_CROSS) then
						elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
						end
						
						_print(trebuc12,235,115,white,l10n.itenskey);
						_print(trebuc12,245,135,white,"--");
						_print(trebuc12,245,150,white,"--");
						
						_print(trebuc12,245,180,white,"$"..itens.money);
						
						endMainFunctions();
						
						if pge.controls.pressed(PGE_CTRL_CIRCLE) then
							break
						end
					end
			menuSelector = 1
			elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
				enabled = true
				state = -1
				guardado = false
				
				if zone == 1 then
					szone = 1
				elseif zone == 2 then
					szone = 2
				elseif zone == casa then
					szone = 3
				elseif zone == casa1 then
					szone = 4
				elseif zone == casa2 then
					szone = 4
				elseif zone == gym then
					szone = 6
				elseif zone == lab then
					szone = 7
				end
				
				if mypokemon == serpifeu or mypokemon == efoserp or mypokemon == serpiroyal  then
					mp = 1
				elseif mypokemon == floink or mypokemon == ferkokel or mypokemon == flambirex then
					mp = 2
				elseif mypokemon == ottaro or mypokemon == zwottronin or mypokemon == admurai then
					mp = 3
				end
				
				if mypokemon then
					dados = ""..xpos.."!"..ypos.."?"..szone.."/"..victories.."@"..tonumber(itens.potion).."|"..tonumber(itens.money).."#"..mp.."*"..tonumber(mypoke.hpr).."&"..tonumber(mypoke.xpr)..""
				else
					dados = ""..xpos.."!"..ypos.."?"..szone.."/"..victories.."@"..tonumber(itens.potion).."|"..tonumber(itens.money)
				end 
				
				if not pge.utils.saveinit(dados, "PSPOKEMON", "PSPOKEMON", l10n.savemsg, l10n.savemsg2) then
					error("Error on save dialog init.")
				end
				
				while pge.running() do
					pge.controls.update()
					pge.gfx.startdrawing()
					pge.gfx.clearscreen()
					--drawmap(savebg)
					pge.gfx.enddrawing()
					
					if enabled then
						-- pge.utils.savedataupdate() must be called after pge.gfx.enddrawing(), but before pge.gfx.swapbuffers()
						state = pge.utils.savedataupdate()
					 
						if state == 0 then
							guardado = true
						elseif state == 1 then
							enabled = false
							break
						elseif state ~= PGE_UTILS_DIALOG_RUNNING then
							enabled = false
							break
						end
					end
					
					pge.gfx.swapbuffers()
					
					if guardado then
						break
					end
					
				end
				state = nil
				enabled = nil
				guardado = nil
			elseif menuSelector == 3 and pge.controls.pressed(PGE_CTRL_CROSS) then
				pge.mp3.stop()
				pge.exit();
			end
			
			endMainFunctions();
			
			if pge.controls.pressed(PGE_CTRL_START) or pge.controls.pressed(PGE_CTRL_CIRCLE) then
				pge.mp3.pause()
				
				menuSelector = nil
				break
			end
		end
	end
	
	function erva()
		
		if moving then
			aparecer = pge.math.randint(0, 50)
			anterior = pge.math.round(segundos:peekdelta())
		end
		
		if aparecer == 29 and mypokemon and anterior > 3 then
			pzone = zone
			zone = battle
			aparecer = 0
		end
	end
	
	function calchp(poke)
		poke.hpbar = ( 60 * poke.hpr ) / poke.hp
		return poke.hpbar
	end
	
	function colorhp(poke)
		if poke.hpbar < 18 then
			return red
		else
			return green
		end
	end
	
	function damage_calc(kind, target)
		limbo = nil
		if kind == "a" then
			z = pge.math.randint(217, 255)
			damage = ((((((((2*subirnivel())/5+2)*mypoke.atk*(mypoke.atk/2))/target.def)+2)*1)*1/10)*z)/255
			target.hpr = target.hpr - damage
			pdamage = pge.math.round(damage)
			movetype = "attack"
		elseif kind == "d" then
			mypoke.defr = mypoke.defr + pge.math.randfloat(0.1, 0.7)
			movetype = "defense"
		end
		
		anim_attack(mypoke, kind);
	end
	
	function enemy_damage_calc()
		z = pge.math.randint(217, 255)
		if zone == trainerbattle then
		damage = pge.math.round(((((((((2*trainer[id].poke[n].lvl)/5+2)*trainer[id].poke[n].atk*(trainer[id].poke[n].atk/2))/mypoke.defr)+2)*1)*1/10)*z)/255)
		else
		damage = pge.math.round(((((((((2*enemy[joker].lvl)/5+2)*enemy[joker].atk*(enemy[joker].atk/2))/mypoke.defr)+2)*1)*1/10)*z)/255)
		end
		mypoke.hpr = mypoke.hpr - damage
		pdamage = damage
		if zone == trainerbattle then	anim_attack(trainer[id].poke[n])
		else anim_attack(enemy[joker]) end
	end
	
	function anim_attack(role, kind)
		local i = 1
		local j = 1
		while pge.running() do
			pge.gfx.startdrawing()
			
			if role == mypoke then
			
				if kind == "a" then
					if role.x < 140 then
						role.x = role.x + 6
						role.y = role.y - 3
						if role.x >= 100 then
							if zone == trainerbattle then
								drawsmap(trainer[id].poke[n].front,trainer[id].poke[n].x,trainer[id].poke[n].y)
							else
								drawsmap(enemy[joker].front,enemy[joker].x,enemy[joker].y)
							end
							pge.gfx.drawstar(345, 40, 7, 15, 8, pge.gfx.createcolor(255, 102, 0, 150))
						end
					else
						break
					end
					pge.gfx.drawrect(0, 100, 235, 104, white)
					drawsmap(role.back,role.x,role.y)
				end
				if kind == "d" then
					i = i + 1
					j = j + 1
					if i < 25 then
						pge.gfx.drawstar(85, 185, i, j, 8, pge.gfx.createcolor(255, 255, 255, 100))
					else
						i = nil
						j = nil
						break
					end
				end
			else
			
				if role.x > 225 then
						role.x = role.x - 6
						role.y = role.y + 3
						if role.x <= 300 then
						   evolution();
							drawsmap(mypoke.back,mypoke.x,mypoke.y)
							pge.gfx.drawstar(105, 175, 7, 15, 8, pge.gfx.createcolor(255, 102, 0, 150))
						end
					else
						break
					end
					pge.gfx.drawrect(200, 10, 280, 104, white)
					drawsmap(role.front,role.x,role.y)
				
			end

			endMainFunctions();
		end
	end
	
	function anim_die()
		while pge.running() do
			pge.gfx.startdrawing()

			trainer[id].poke[n-1].y = trainer[id].poke[n-1].y + 4
			
			if trainer[id].poke[n-1].y < 90 then
				pge.gfx.drawrect(200, 10, 280, 125, white)
				drawsmap(trainer[id].poke[n-1].front,trainer[id].poke[n-1].x,trainer[id].poke[n-1].y)
			else
				break
			end
			
			endMainFunctions();
		end
	end
	
	function hp_restore()
	mypoke.hpr = mypoke.hp
	fade = pge.gfx.createcolor(0, 0, 0, 0)
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.drawrect(0, 0, 480, 272, fade)
			alphavalue = pge.gfx.alpha(fade)
			pge.gfx.alpha(fade, alphavalue + 1)
			if alphavalue >= 100 then
				drawsmap(dialog,120, 71);
				trebuc16:activate();
				trebuc16:printcenter(81, white, l10n.bed1)
				trebuc12:activate();
				trebuc12:printcenter(125, white, l10n.bed2)
				trebuc12:printcenter(140, white, l10n.bed3)
				if pge.controls.pressed(PGE_CTRL_CIRCLE) then
					break
				end
			end
			endMainFunctions();
		end
	end
	
	function talk(title, text1, text2, text3)
		if not text3 then
			text3 = ""
		end
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()
			drawsmap(dialog,120, 71);
			trebuc16:activate();
			trebuc16:printcenter(81, white, title)
			trebuc12:activate();
			trebuc12:printcenter(125, white, text1)
			trebuc12:printcenter(140, white, text2)
			trebuc12:printcenter(155, white, text3)
			if pge.controls.pressed(PGE_CTRL_CIRCLE) then
				break
			end
			endMainFunctions();
		end
	end
	
	function lixo()
		aparecer = pge.math.randint(0, 50)
		if aparecer < 19 then
			talk(l10n.trash1, l10n.trash2, "");
			itens.potion = itens.potion + 1
		else
			talk(l10n.trash3, l10n.trash4, "");
		end
	end
	
	function usepotion()
		if mypokemon and itens.potion > 0 then
			limbo = nil
			seed = pge.math.randint(mypoke.hp/4, mypoke.hp/2)
			mypoke.hpr = mypoke.hpr + seed
			if mypoke.hpr > mypoke.hp then
				mypoke.hpr = mypoke.hp
			end
			itens.potion = itens.potion - 1
			if zone ~= battle and zone ~= trainerbattle then
				talk(l10n.itens2,l10n.potionuse,"");
			else
				movetype = nil
				itensuse = 1
				counter = 2
			end
		end
	end
	
	function drawtrainer(character,id,minx,maxx,miny,maxy)
		
		con = 1
		
		if ypos == trainer[id].y+SPRITEDIM-14 or xpos == trainer[id].x-SPRITEDIM+4 or ypos == trainer[id].y-SPRITEDIM+2 or xpos == trainer[id].x+SPRITEDIM-4 then		
		
			if ypos == trainer[id].y+SPRITEDIM-14 and xpos > trainer[id].x-SPRITEDIM+5 and xpos < trainer[id].x+SPRITEDIM-5 then
				trainer[id].x = trainer[id].x
				trainer[id].y = trainer[id].y	
				trainer[id].offset = SPRITESTANDDOWN
				trainer[id].animframe = 0
				con = 0
			elseif ypos == trainer[id].y-SPRITEDIM+2 and xpos > trainer[id].x-SPRITEDIM+5 and xpos < trainer[id].x+SPRITEDIM-5 then
				trainer[id].x = trainer[id].x
				trainer[id].y = trainer[id].y	
				trainer[id].offset = SPRITESTANDUP
				trainer[id].animframe = 0
				con = 0
			elseif xpos == trainer[id].x+SPRITEDIM-4 and ypos > trainer[id].y-SPRITEDIM+5 and ypos < trainer[id].y+SPRITEDIM-15 then
				trainer[id].x = trainer[id].x
				trainer[id].y = trainer[id].y
				trainer[id].offset = SPRITESTANDRIGHT				
				trainer[id].direction = RIGHT
				trainer[id].animframe = 0
				con = 0
			elseif xpos == trainer[id].x-SPRITEDIM+4 and ypos > trainer[id].y-SPRITEDIM+5 and ypos < trainer[id].y+SPRITEDIM-15 then
				trainer[id].x = trainer[id].x
				trainer[id].y = trainer[id].y
				trainer[id].offset = SPRITESTANDLEFT
				trainer[id].direction = LEFT
				trainer[id].animframe = 0
				con = 0
			end
			
		end
		
		if con == 1 then
			
			if trainer[id].y <= miny then
				trainer[id].x = trainer[id].x + 0.5
				trainer[id].y = miny
				trainer[id].offset = SPRITEWALKRIGHT
				trainer[id].direction = RIGHT
			end
			
			if trainer[id].x >= maxx then
				trainer[id].x = maxx
				trainer[id].y = trainer[id].y + 0.5
				trainer[id].offset = SPRITEWALKDOWN
				trainer[id].direction = DOWN
			end
			
			if trainer[id].y >= maxy then
				trainer[id].x = trainer[id].x - 0.5
				trainer[id].y =  maxy
				trainer[id].offset = SPRITEWALKLEFT
				trainer[id].direction = LEFT
			end
			
			if trainer[id].x <= minx then
				trainer[id].x = minx
				trainer[id].y = trainer[id].y - 0.5
				trainer[id].offset = SPRITEWALKUP
				trainer[id].direction = UP
			end
		
		end
		
		a = (trainer[id].offset + trainer[id].animframe) * SPRITEDIM
		c = SPRITEDIM
		b = 0
		d = SPRITEDIM

		if trainer[id].direction == LEFT then
			a = (trainer[id].offset + trainer[id].animframe + 1) * SPRITEDIM
			c = 0 - SPRITEDIM
		end
		
		trainer[id].animwait = trainer[id].animwait - 1
		
		if trainer[id].animwait <= 0 then
			trainer[id].animwait = ANIMWAIT
			trainer[id].animframe = trainer[id].animframe + 1
			
			if trainer[id].animframe >= ANIMFRAMES then
				trainer[id].animframe = 0
			end
		end
		
		character:activate()
		character:draw(trainer[id].x, trainer[id].y, SPRITEDIM, SPRITEDIM,a, b,c,d)
	end
	
	function trainertalk(id)
		if pge.controls.pressed(PGE_CTRL_CROSS) then
			if mypokemon then
				talk(l10n.trainerytitle, l10n.trainery1, l10n.trainery2);
				tid = id
				pzone = zone
				zone = trainerbattle
			else
				talk(l10n.trainerntitle, l10n.trainern1, l10n.trainern2, l10n.trainern3);
			end
		end
	end
	
	function business()
		
		local mSi = 0
		q1 = 0
		q2 = 0
		q3 = 0
		p1 = 300
		p2 = 0
		p3 = 0
		
		while pge.running() do
			pge.controls.update()
			pge.gfx.startdrawing()
			drawsmap(dialog,120, 71);
			trebuc16:activate();
			trebuc16:printcenter(81, white, l10n.sellertitle)
			
			if q1 < 0 then
				q1 = 0
			end
			
			_print(trebuc12,135,150,white,l10n.itens1);
			_print(trebuc12,135,165,white,"--");
			_print(trebuc12,135,180,white,"--");
			
			_print(trebuc12,190,150,white,q1);
			_print(trebuc12,190,165,white,q2);
			_print(trebuc12,190,180,white,q3);
			
			if pge.controls.pressed(PGE_CTRL_UP) then
				mSi = mSi - 1
			elseif pge.controls.pressed(PGE_CTRL_DOWN) then
				mSi = mSi + 1
			end
			
			if mSi >= 3 then
				mSi = 0
			elseif mSi < 0 then
				mSi = 2
			end
			
			if mSi == 0 then
				_print(trebuc12,135,150,blue,l10n.itens1);
				_print(trebuc12,190,150,blue,q1);
				
				if pge.controls.pressed(PGE_CTRL_RIGHT) then
					q1 = q1 + 1
				elseif pge.controls.pressed(PGE_CTRL_LEFT) then
					q1 = q1 - 1
				end
			elseif mSi == 1 then
				_print(trebuc12,135,165,blue,"--");
				_print(trebuc12,190,165,blue,q2);
			elseif mSi == 2 then
				_print(trebuc12,135,180,blue,"--");
				_print(trebuc12,190,180,blue,q3);
			end

			tospend = q1*p1 + q2*p2 + q3*p3
			
			if tospend <= itens.money then
				moneycolor = white
			else
				moneycolor = red
			end
			
			_print(trebuc12,245,120,white,l10n.sellerm1);
			_print(trebuc12,245,135,white,"$"..itens.money);
			_print(trebuc12,245,150,white,l10n.sellerm2);
			_print(trebuc12,245,165,moneycolor,"$"..tospend);
			
			if tospend <= itens.money and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.sellerb1, l10n.sellerb2, "");
				itens.money = itens.money - tospend
				itens.potion = itens.potion + q1
				break
			end
			
			if pge.controls.pressed(PGE_CTRL_CIRCLE) then
				break
			end
			endMainFunctions();
		end
	end
	
	function computer()
		if mypokemon and victories > 0 then
	   	email = pge.math.randint(1,5)
			if email < 3 then
			talk("Schade", "Ich habe leider", "keine neue Email.", "Ich probiers nachher");
			else
			talk("Gut.", "Ich habe eine neue", "Email von Profesor Esche.", "Ich lese sie nachher.")
			end
		else
			while pge.running() do
				pge.controls.update()
				pge.gfx.startdrawing()
				pge.gfx.clearscreen()
				
				trebuc16:activate();
				trebuc16:printcenter(130, white, l10n.netoffline)
				
				if pge.controls.pressed(PGE_CTRL_CIRCLE) then
					break
				end
				endMainFunctions()
				
			end
		end
	end
	
	function getattack3()
   ataque3="--"
	if mypoke.xpr > 180 then
	   if mypokemon == serpifeu or mypokemon == efoserp or mypokemon == serpiroyal  then
	 	 ataque3 = l10n.attack3
		end 
		 if mypokemon == floink or mypokemon == ferkokel or mypokemon == flambirex then
	 	 ataque3 = 	l10n.attack5
		end 
	   if mypokemon == ottaro or mypokemon == zwottronin or mypokemon == admurai then
	 	 ataque3 = 	l10n.attack6
		end 

	end
	return ataque3
	
	end
	
	
	function getattack4()
   ataque4="--"
	if mypoke.xpr > 1150 then
	 	 if mypokemon == serpifeu or mypokemon == efoserp or mypokemon == serpiroyal  then
	 	 ataque4 = 	l10n.attack7
		end 
		 if mypokemon == floink or mypokemon == ferkokel or mypokemon == flambirex then
	 	 ataque4 = 	l10n.attack8	
		end 
	   if mypokemon == ottaro or mypokemon == zwottronin or mypokemon == admurai then
	 	 ataque4 = 	l10n.attack9
		end 
   end		
	return ataque4
	
	end
	
	
	
		function subirnivel()
	
	nivelnuevo = 5

	if mypoke.xpr > 0 and mypoke.xpr <= 80 then
	  nivelnuevo = 5
	end
	if mypoke.xpr > 80 and mypoke.xpr <= 180 then
	  nivelnuevo = 6
	end
	if mypoke.xpr > 180 and mypoke.xpr <= 280 then
	  nivelnuevo = 7
	end
	if mypoke.xpr > 280 and mypoke.xpr <= 400 then
	  nivelnuevo = 8
	end
	if mypoke.xpr > 400 and mypoke.xpr <= 550 then
	  nivelnuevo = 9
	end
	if mypoke.xpr > 550 and mypoke.xpr <= 700 then
	  nivelnuevo = 10
	end
	if mypoke.xpr > 700 and mypoke.xpr <= 900 then
	  nivelnuevo = 11
	end
	if mypoke.xpr > 900 and mypoke.xpr <= 1150 then
	  nivelnuevo = 12
	end
	if mypoke.xpr > 1150 and mypoke.xpr <= 1300 then
	  nivelnuevo = 13
	end
	if mypoke.xpr > 1300 and mypoke.xpr <= 1650 then
	  nivelnuevo = 14
	end
	if mypoke.xpr > 1650 then
	  nivelnuevo = 15
	end
	return nivelnuevo
	
	end
	
	
	
	function evolution()
	
	if mypoke.xpr > 550 and mypoke.xpr < 1650 then
	  
	   if mypokemon == serpifeu then
	 	 mypoke.name = l10n.pokemon10
		 mypoke.back = efoserp_back	
		 mypokemon = efoserp
		 mypoke.atk = 9
	   end 
	   if mypokemon == floink then
	 	 mypoke.name = l10n.pokemon9
		 mypoke.back = ferkokel_back
		 mypokemon = ferkokel
 		 mypoke.atk = 9
		end 
	   if mypokemon == ottaro then
	 	 mypoke.name = l10n.pokemon11
		 mypoke.back = zwottronin_back		
		 mypokemon = zwottronin
		 mypoke.atk = 9
		end 
   end
	
   if mypoke.xpr > 1650 then
	
	   if mypokemon == serpifeu or mypokemon == efoserp then
	 	 mypoke.name = l10n.pokemon13
		 mypoke.back = serpiroyal_back
		 mypokemon = serpiroyal 
		 mypoke.atk = 12
		end 
		 if mypokemon == floink or mypokemon == ferkokel then
	 	 mypoke.name = l10n.pokemon12
		 mypoke.back = flambirex_back
		 mypokemon = flambirex	
		 mypoke.atk = 12
		end 
	   if mypokemon == ottaro or mypokemon == zwottronin then
	 	 mypoke.name = l10n.pokemon14
		 mypoke.back = admurai_back		
		 mypokemon = admurai
		 mypoke.atk = 12
		end 

	end 
	end