--[[
	Develop by:
		mrfyda aka Rafael Corts
		D4NnY aka Daniel Caetano
		TEAM B&D formado por bixu y DAV-MON
		Shaplayer
		
	Code license under:
		Attribution-Noncommercial-Share Alike 3.0 Unported License
		http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
		 2009 - 2010
]]

pge.usb.init()
pge.usb.activate()

-- Version
version = 0.03

-- Colors
black = pge.gfx.createcolor(0, 0, 0)
white = pge.gfx.createcolor(255, 255, 255)
red = pge.gfx.createcolor(255, 0, 0)
green = pge.gfx.createcolor(0, 255, 53)
blue = pge.gfx.createcolor(0 , 153, 255)
pink = pge.gfx.createcolor(255, 0, 153)
orange = pge.gfx.createcolor(255, 102, 0)
gray = pge.gfx.createcolor(153, 153, 153)

-- Language
lang = pge.utils.language()

if  lang == PGE_UTILS_LANGUAGE_GERMAN then
	lang = "de"
else
	lang = "en"
end
l10n = {}
dofile('Content/Scripts/'..lang..'.lua');


-- Loading
dofile('Content/Scripts/functions.lua');
trebuc12 = pge.font.load("Content/Font/trebuc.ttf", 12, PGE_VRAM)
trebuc16 = pge.font.load("Content/Font/trebuc.ttf", 16, PGE_VRAM)
powered = pge.texture.load("Content/GFX/pgepowered.png", PGE_RAM)
	
	-- PGE Loading
	pge.gfx.startdrawing()
	pge.gfx.clearscreen()
	drawmap(powered);
	trebuc16:activate();
	trebuc16:printcenter(240, orange, l10n.loading)
	endMainFunctions();

menu = pge.texture.load("Content/GFX/menu.png", PGE_RAM)
menu2 = pge.texture.load("Content/GFX/menu2.png", PGE_RAM)
--savebg = pge.texture.load("Content/GFX/PIC1.png", PGE_RAM)
zona1 = pge.texture.load("Content/GFX/zona1.png", PGE_RAM)
zona2 = pge.texture.load("Content/GFX/zona2.png", PGE_RAM)
casa = pge.texture.load("Content/GFX/hq.png", PGE_RAM)
casa1 = pge.texture.load("Content/GFX/hq2.png", PGE_RAM)
casa2 = pge.texture.load("Content/GFX/casa.png", PGE_RAM)
lab = pge.texture.load("Content/GFX/lab.png", PGE_RAM)
gym = pge.texture.load("Content/GFX/gym.png", PGE_RAM)
battle = pge.texture.load("Content/GFX/battle.png", PGE_RAM)
battle2 = pge.texture.load("Content/GFX/battle2.png", PGE_RAM)
battle3 = pge.texture.load("Content/GFX/battle3.png", PGE_RAM)
ash = pge.texture.load("Content/GFX/ash.png", PGE_RAM)
ash_back = pge.texture.load("Content/GFX/ash_back.png", PGE_RAM)
trainer0 = pge.texture.load("Content/GFX/trainer0.png", PGE_RAM)
trainer0_r = pge.texture.load("Content/GFX/trainer0_right.png", PGE_RAM)
trainer0_l = pge.texture.load("Content/GFX/trainer0_left.png", PGE_RAM)
trainer1 = pge.texture.load("Content/GFX/trainer1.png", PGE_RAM)
trainer2 = pge.texture.load("Content/GFX/trainer2.png", PGE_RAM)
seller = pge.texture.load("Content/GFX/seller.png", PGE_RAM)
oak = pge.texture.load("Content/GFX/Kodama.png", PGE_RAM)
pause = pge.texture.load("Content/GFX/pause.png", PGE_RAM)
dialog = pge.texture.load("Content/GFX/dialog.png", PGE_RAM)
pokemenu = pge.texture.load("Content/GFX/pokemenu.png", PGE_RAM)
bag = pge.texture.load("Content/GFX/bag.png", PGE_RAM)
serpifeu = pge.texture.load("Content/GFX/serpifeu.png", PGE_RAM)
serpifeu_back = pge.texture.load("Content/GFX/serpifeu_back.png", PGE_RAM)
floink = pge.texture.load("Content/GFX/floink.png", PGE_RAM)
floink_back = pge.texture.load("Content/GFX/floink_back.png", PGE_RAM)
ottaro = pge.texture.load("Content/GFX/ottaro.png", PGE_RAM)
ottaro_back = pge.texture.load("Content/GFX/ottaro_back.png", PGE_RAM)

efoserp = pge.texture.load("Content/GFX/Efoserp.png", PGE_RAM)
efoserp_back = pge.texture.load("Content/GFX/Efoserp_back.png", PGE_RAM)
ferkokel = pge.texture.load("Content/GFX/Ferkokel.png", PGE_RAM)
ferkokel_back = pge.texture.load("Content/GFX/Ferkokel_back.png", PGE_RAM)
zwottronin = pge.texture.load("Content/GFX/Zwottronin.png", PGE_RAM)
zwottronin_back = pge.texture.load("Content/GFX/Zwottronin_back.png", PGE_RAM)


admurai = pge.texture.load("Content/GFX/Admurai.png", PGE_RAM)
admurai_back = pge.texture.load("Content/GFX/Admurai_back.png", PGE_RAM)
serpiroyal  = pge.texture.load("Content/GFX/Serpiroyal .png", PGE_RAM)
serpiroyal_back = pge.texture.load("Content/GFX/Serpiroyal_back.png", PGE_RAM)
flambirex = pge.texture.load("Content/GFX/Flambirex.png", PGE_RAM)
flambirex_back = pge.texture.load("Content/GFX/Flambirex_back.png", PGE_RAM)


received = pge.wav.load("Content/SFX/received.wav")
pge.mp3.play("Content/SFX/menu.mp3")
pge.mp3.loop(true)

-- Loading checks
if not trebuc12 or not ash or not zona1 then
	error(l10n.loaderror)
end
	
run = false
menuSelector = 0

while pge.running() do
	
	pge.controls.update()
	pge.gfx.startdrawing()
	pge.gfx.clearscreen()
	
	drawmap(menu)
	
	if pge.controls.pressed(PGE_CTRL_UP) then
		menuSelector = menuSelector - 1
	elseif pge.controls.pressed(PGE_CTRL_DOWN) then
		menuSelector = menuSelector + 1
	end
	
	if menuSelector >= 2 then
		menuSelector = 0
	elseif menuSelector < 0 then
		menuSelector = 1
	end
	
	if menuSelector == 1 then
	drawmap(menu2)
	end

	endMainFunctions();
	
	if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
		zone = 1
		xpos = 55.0
		ypos = 125.0
		itens = {}
		itens.potion = 0
		itens.money = 1000
		victories = 0
		
		run = true
		break
	end
	
	if menuSelector == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
		loadgame();
		
		if carregado then
			if mypokemon then
				dofile('Content/Scripts/pokemon.lua');
				mypoke.hpr = shpr
				mypoke.xpr = sxpr
			end
			
			itens = {}
			itens.potion = potions
			itens.money = money
			
			run = true
			break
		end
	end
	
end

powered = nil
menu = nil
menu2 = nil
neocomp = nil
menuSelector = nil


if run == true then

	pge.mp3.play("Content/SFX/hometown.mp3")
	pge.mp3.loop(true)
	
	-- Setup some variables we will use for the spritesheet 
	UP = 0
	DOWN = 1
	LEFT = 2
	RIGHT = 3

	SPRITEDIM = 30

	ANIMFRAMES = 3
	ANIMWAIT = 5

	SPRITESIT = 0
	SPRITEWALKDOWN = 1
	SPRITESTANDDOWN = 2
	SPRITEWALKRIGHT = 4
	SPRITESTANDRIGHT = 5
	SPRITEWALKLEFT = 4
	SPRITESTANDLEFT = 5
	SPRITEWALKUP = 7
	SPRITESTANDUP = 8

	direction = RIGHT
	animframe = 0
	animwait = 10
	spriteoffset = SPRITESTANDRIGHT
	zoom = 1.0
	walkspeed = 1.0
	
	-- Trainers
	if not trainer then
		trainer = {}
		trainer[0] = {}
		trainer[1] = {}
		trainer[2] = {}
	end
	
	trainer[0].subject = l10n.subjectm
	trainer[0].name = "Maik"
	trainer[0].x = 229
	trainer[0].y = 50
	trainer[0].direction = "down"
	trainer[0].offset = SPRITESTANDDOWN
	trainer[0].animwait = 10
	trainer[0].animframe = 0
	trainer[0].front = pge.texture.load("Content/GFX/maik_front.png", PGE_RAM)

	trainer[1].subject = l10n.subjectm
	trainer[1].name = "Lukas"
	trainer[1].x = 30
	trainer[1].y = 170
	trainer[1].offset = SPRITESTANDRIGHT
	trainer[1].animwait = 10
	trainer[1].animframe = 0
	trainer[1].front = pge.texture.load("Content/GFX/Lukas_front.png", PGE_RAM)

	trainer[2].subject = l10n.subjectf
	trainer[2].name = "Sarah"
	trainer[2].x = 380
	trainer[2].y = 225
	trainer[2].offset = SPRITESTANDRIGHT
	trainer[2].animwait = 10
	trainer[2].animframe = 0
	trainer[2].front = pge.texture.load("Content/GFX/Sarah_front.png", PGE_RAM)
	
	-- Trimers
	segundos = pge.timer.create()

	while pge.running() do
		
		if zone == 1 then
			
		   
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			drawmap(zona1);
			
			drawtrainer(trainer1,1,30,175,170,205)
			
			drawhero();
			animatehero();
			
			endMainFunctions();
			
			-- Go to Zone2
			if xpos > 279 and xpos < 320 and ypos < 5 then
				ypos = 233
				zone = 2
			
			end
			
			-- casa2
			if xpos >= 400 and xpos <= 404 and ypos > 215 and ypos < 226 then
				xpos = 213
				ypos = 175
				zone = casa2
				pge.mp3.stop()
			   pge.mp3.play("Content/SFX/center.mp3")
			end
			
			-- relva
			if xpos >= 360 and xpos < 390 and ypos > 75 and ypos <= 106 then
				erva();
			end
			if xpos < 80 and ypos > 40 and ypos <= 71 then
				erva();
			end
			
			-- treinador
			if xpos > trainer[1].x-SPRITEDIM+5 and xpos < trainer[1].x+SPRITEDIM-5 and ypos > trainer[1].y+SPRITEDIM-16 and ypos < trainer[1].y+SPRITEDIM-14 then
				ypos = trainer[1].y+SPRITEDIM-14
			end
			
			if xpos > trainer[1].x-SPRITEDIM+4 and xpos < trainer[1].x and ypos > trainer[1].y-SPRITEDIM+5 and ypos < trainer[1].y+SPRITEDIM-15 then
				xpos = trainer[1].x-SPRITEDIM+4
			end
			
			if xpos > trainer[1].x-SPRITEDIM+5 and xpos < trainer[1].x+SPRITEDIM-5 and ypos > trainer[1].y-SPRITEDIM+2 and ypos < trainer[1].y-SPRITEDIM+4 then
				ypos = trainer[1].y-SPRITEDIM+2
			end
			
			if xpos > trainer[1].x+SPRITEDIM-6 and xpos < trainer[1].x+SPRITEDIM-4 and ypos > trainer[1].y-SPRITEDIM+5 and ypos < trainer[1].y+SPRITEDIM-15 then
				xpos = trainer[1].x+SPRITEDIM-4
			end
			
			if con == 0 then
				trainertalk(1);
			end
			
			if xpos < 12 then
				xpos = 12
			end
			
			if xpos < 34 and ypos < 100 then
				xpos = 34
			end
			
			if ypos < 7 and xpos < 82 then
				ypos = 7
			end
			
			if xpos > 80 and xpos < 82 and ypos < 48 then
				xpos = 80
			end
			
			if xpos < 52 and ypos > 90 and ypos < 100 then
				ypos = 90
			end
			
			if xpos < 54 and ypos > 90 and ypos < 148 then
				xpos = 54
			end
			
			if xpos < 52 and ypos > 102 and ypos < 150 then
				ypos = 150
			end
			
			if xpos < 272 and ypos > 210 then
				ypos = 210
			end
			
			if xpos < 274 and ypos > 210 then
				xpos = 274
			end
			
			if xpos > 272 and ypos > 230 then
				ypos = 230
			end
			
			if xpos > 447 and ypos < 232 then
				xpos = 447
			end
			
			if xpos > 319 and ypos < 7 then
				ypos = 7
			end
			
			if xpos < 280 and ypos < 7 then
				ypos = 7
			end
			
			if xpos < 448 and xpos > 366 and ypos > 160 and ypos < 163 then
				ypos = 160
			end
		 
			if ypos < 202 and ypos > 162 and xpos > 365 then
				xpos = 365
			end 
		 
			if xpos < 449 and xpos > 404 and ypos < 231 and ypos > 225 then
				ypos = 230
			end 
		 
			if xpos < 400 and xpos > 350 and ypos < 231 and ypos > 225 then
				ypos = 230
			end 
		 
			if ypos > 200 and ypos < 202 and xpos > 350 and xpos < 367 then
				ypos = 200
			end
		 
			if ypos < 230 and ypos > 199 and xpos > 350 and xpos < 352 then
				xpos = 350
			end

			if xpos > 360 and xpos < 375 and ypos > 225 and ypos < 231 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.tab2title, l10n.tab2text1, l10n.tab2text2);
			end
		 
			if xpos > 80 and xpos < 108 and ypos < 48 then
				ypos = 48
			end
			
			if xpos > 170 and xpos < 180 and ypos < 40 then
				xpos = 180
			end
			
			-- Casa
			if xpos >= 106 and xpos <= 111 and ypos < 46 then
				xpos = 189
				ypos = 187
				zone = casa
				 pge.mp3.stop()
		     	 pge.mp3.play("Content/SFX/center.mp3")
			end
			
			if xpos > 111 and xpos < 195 and ypos > 25 and ypos < 48 then
				ypos = 48
			end
			
			if xpos > 179 and xpos < 198 and ypos > 21 and ypos < 40 then
				ypos = 21
			end
			
			if xpos > 190 and xpos < 197 and ypos > 21 and ypos < 48 then
				xpos = 197
			end
			
			if xpos > 179 and xpos < 198 and ypos > 25 and ypos < 49 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.tab1title, l10n.tab1text1, l10n.tab1text2);
			end
		 
		end
		
		if zone == 2 then
			
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			drawmap(zona2);
		 
			drawtrainer(trainer2,2,380,435,105,215)
		 
			drawhero();
			animatehero();
			
			endMainFunctions();
			
			-- Go to Lab
			if xpos > 275 and xpos < 292 and ypos < 95 then
				xpos = 226
				ypos = 213
				zone = lab
				
			end
			
			-- Go to Gym
			if xpos > 84 and xpos < 103 and ypos < 95 and mypokemon then
				xpos = 229
				ypos = 228
				zone = gym
			
			elseif xpos > 84 and xpos < 103 and ypos < 95 then
				xpos = 84.5
				ypos = 104
				talk(l10n.gym1, l10n.gym2, l10n.gym3);
			end
			
			-- Go to Zone1
			if xpos > 280 and xpos < 315 and ypos > 235 then
				ypos = 8
				zone = 1
			end
			
			-- treinador
			if xpos > trainer[2].x-SPRITEDIM+5 and xpos < trainer[2].x+SPRITEDIM-5 and ypos > trainer[2].y+SPRITEDIM-16 and ypos < trainer[2].y+SPRITEDIM-14 then
				ypos = trainer[2].y+SPRITEDIM-14
			end
			
			if xpos > trainer[2].x-SPRITEDIM+4 and xpos < trainer[2].x and ypos > trainer[2].y-SPRITEDIM+5 and ypos < trainer[2].y+SPRITEDIM-15 then
				xpos = trainer[2].x-SPRITEDIM+4
			end
			
			if xpos > trainer[2].x-SPRITEDIM+5 and xpos < trainer[2].x+SPRITEDIM-5 and ypos > trainer[2].y-SPRITEDIM+2 and ypos < trainer[2].y-SPRITEDIM+4 then
				ypos = trainer[2].y-SPRITEDIM+2
			end
			
			if xpos > trainer[2].x+SPRITEDIM-6 and xpos < trainer[2].x+SPRITEDIM-4 and ypos > trainer[2].y-SPRITEDIM+5 and ypos < trainer[2].y+SPRITEDIM-15 then
				xpos = trainer[2].x+SPRITEDIM-4
			end
			
			if con == 0 then
				trainertalk(2);
			end
			
			if xpos > 314 and ypos > 232 then
				ypos = 232
			end
			
			if xpos < 279 and ypos > 232 then
				ypos = 232
			end
			
			if xpos > 449 and zone then
				xpos = 449
			end
			
			if xpos > 420 and ypos < 66 then
				ypos = 66
			end
			
			if xpos > 424 and xpos < 426 and ypos < 80 then
				xpos = 426
			end
			
			if xpos > 402 and xpos < 426 and ypos < 80 then
				ypos = 80
			end
			
			if xpos > 400 and xpos < 404 and ypos < 80 then
				xpos = 400
			end
			
			if xpos > 380 and xpos < 404 and ypos < 26 then
				ypos = 26
			end
			
			if xpos > 380 and xpos < 382 and ypos < 80 then
				xpos = 382
			end
			
			if xpos > 370 and xpos < 380 and ypos < 80 then
				ypos = 80
			end
			
			if xpos > 371 and xpos < 373 and ypos < 97 then
				xpos = 373
			end
			
			if xpos > 291 and xpos < 371 and ypos < 97 and zone ~= 1 then
				ypos = 97
			end
			
			if xpos > 182 and xpos <= 275 and ypos < 97 then
				ypos = 97
			end
			
			if xpos > 180 and xpos < 182 and ypos < 97 then
				xpos = 180
			end
			
			if xpos > 150 and xpos < 182 and ypos < 26 then
				ypos = 26
			end
			
			if xpos > 158 and xpos < 160 and ypos < 104 then
				xpos = 160
			end
			
			if xpos > 92 and xpos < 158 and ypos < 104 then
				ypos = 104
			end
			
			if xpos > 22 and xpos <= 84 and ypos < 104 then
				ypos = 104
			end
			
			if xpos > 50 and xpos < 53 and ypos > 100 and ypos < 113 then
				xpos = 53
			end
			
			if xpos > 30 and xpos < 42 and ypos < 116 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.tab3title, l10n.tab3text1, l10n.tab3text2);
			end
			
			if xpos > 22 and xpos < 53 and ypos < 115 then
				ypos = 115
			end
			
			if xpos > 20 and xpos < 22 and ypos < 113 then
				xpos = 20
			end
			
			if xpos < 22 and ypos < 7 then
				ypos = 7
			end
			
			if xpos < 12 then
				xpos = 12
			end
			
			if xpos < 158 and ypos > 122 and ypos < 124 then
				ypos = 122
			end
			
			if xpos < 160 and ypos > 124 and ypos < 150 then
				xpos = 160
			end
			
			if xpos < 158 and ypos > 150 and ypos < 152 then
				ypos = 152
			end
			
			if xpos < 20 and ypos > 228 and ypos < 230  then
				ypos = 230
			end
			
			if xpos < 22 and ypos > 150 and ypos < 230 then
				xpos = 22
			end
			
			-- Erva
			if xpos > 20 and xpos < 144 and ypos > 155 and ypos < 224 then
				erva();
			end
			if xpos > 382 and xpos < 400 and ypos > 33 and ypos < 60 then
				erva();
			end
		end
		
		if zone == casa then
			
			
	     
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			zonex = 144
			zoney = 59.5
			drawsmap(casa,zonex,zoney);
		 
			drawhero();
			animatehero();
			
			endMainFunctions();

			if xpos > 138 and xpos < 183 and ypos > 185 and ypos < 190 then
				ypos = 185
			end

			if xpos > 138 and xpos < 142 and ypos > 182 and ypos < 188 then
				xpos = 142
			end

			if xpos > 139 and xpos < 158 and ypos > 180 and ypos < 184 then
				ypos = 184
			end

			if xpos > 156 and xpos < 159 and ypos > 138 and ypos < 184 then
				xpos = 159
			end

			if xpos > 138 and xpos < 159 and ypos > 138 and ypos < 144 then
				ypos = 138
			end

			if xpos > 136 and xpos < 142 and ypos > 88 and ypos < 145 then
				xpos = 142
			end

			if xpos > 135 and xpos < 205 and ypos > 88 and ypos < 90 then
				ypos = 90
			end

			if xpos > 202 and xpos < 205 and ypos > 75 and ypos < 90 then
				xpos = 205
			end
			
			if xpos > 202 and xpos <= 205 and ypos > 75 and ypos < 90 and pge.controls.pressed(PGE_CTRL_CROSS) then
				lixo();
			end

			if xpos > 203 and xpos < 207 and ypos > 77 and ypos < 79 then
				ypos = 79
			end

			if xpos > 205 and xpos < 209 and ypos > 76 and ypos < 90 then
				xpos = 205
			end

			if xpos > 205 and xpos < 238 and ypos > 86 and ypos < 90 then
				ypos = 90
			end

			if xpos > 230 and xpos < 238 and ypos > 74 and ypos < 90 then
				xpos = 238
			end

			if xpos > 233 and xpos < 289 and ypos > 73 and ypos < 79 then
				ypos = 79
			end

			if xpos > 284 and xpos < 350 and ypos > 106 and ypos < 109 then
				ypos = 109
			end

			if xpos > 315 and xpos < 320 and ypos > 107 and ypos < 142 then
				xpos = 315
			end

			if xpos > 300 and xpos < 340 and ypos > 139 and ypos < 145 then
				ypos = 139
			end

			if xpos > 300 and xpos < 305 and ypos > 139 and ypos < 184 then
				xpos = 300
			end

			if xpos > 284 and xpos < 288 and ypos > 96 and ypos < 109 then
				xpos = 284
			end

			if xpos > 300 and xpos < 325 and ypos > 181 and ypos < 184 then
				ypos = 184
			end

			if xpos > 315 and xpos < 323 and ypos > 183 and ypos < 190 then
				xpos = 315
			end

			if xpos > 192 and xpos < 330 and ypos > 185 and ypos < 188 then
				ypos = 185
			end

			if xpos > 187 and xpos < 272 and ypos > 145 and ypos < 150 then
				ypos = 150
			end

			if xpos > 187 and xpos < 190 and ypos > 105 and ypos < 150 then
				xpos = 187
			end

			if xpos > 187 and xpos < 272 and ypos > 105 and ypos < 110 then
				ypos = 105
			end

			if xpos > 268 and xpos < 272 and ypos > 105 and ypos < 150 then
				xpos = 272
			end

			-- Piso 2
			if xpos > 289 and ypos < 97 and ypos > 72 then
				xpos = 299
				ypos = 93
				zone = casa1
				
			end

			-- Go to Zone1
			if xpos > 183 and xpos < 192 and ypos > 186 then
				xpos = 113
				ypos = 50
				zone = 1
				pge.mp3.stop()
			   pge.mp3.play("Content/SFX/hometown.mp3")
	         
			end
		end

		if zone == casa1 then
         
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			zonex = 152
			zoney = 62
			drawsmap(casa1,zonex,zoney);

			drawhero();
			animatehero();

			endMainFunctions();

			if xpos > 298 and xpos < 315 and ypos > 75 and ypos < 81 then
				ypos = 81
			end
			
			if xpos > 300 and xpos < 315 and ypos > 75 and ypos <= 81 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.poster1.." "..pge.utils.nickname().."!",l10n.poster2,l10n.poster3);
			end			

			if xpos > 308 and xpos < 312 and ypos > 79 and ypos < 190 then
				xpos = 308
			end

			if xpos > 145 and xpos < 316 and ypos > 187 and ypos < 191 then
				ypos = 187
			end

			if xpos > 144 and xpos < 150 and ypos > 160 and ypos < 192 then
				xpos = 150
			end

			if xpos > 143 and xpos < 187 and ypos > 158 and ypos < 163 then
				ypos = 163
			end

			if xpos > 160 and xpos < 163 and ypos > 119 and ypos < 163 then
				xpos = 163
			end

			if xpos > 144 and xpos < 185 and ypos > 119 and ypos < 122 then
				ypos = 119
			end

			if xpos > 146 and xpos < 150 and ypos > 85 and ypos < 125 then
				xpos = 150
			end

			if xpos > 142 and xpos < 230 and ypos > 86 and ypos < 90 then
				ypos = 90
			end
			
			if xpos > 142 and xpos < 154 and ypos > 86 and ypos <= 90 and pge.controls.pressed(PGE_CTRL_CROSS) then
				computer();
			end

			if xpos > 227 and xpos < 230 and ypos > 80 and ypos < 90 then
				xpos = 230
			end

			if xpos > 228 and xpos < 249 and ypos > 84 and ypos < 86 then
				ypos = 86
			end

			if xpos > 245 and xpos < 248 and ypos > 83 and ypos < 116 then
				xpos = 245
			
			end
			
            if xpos == 228 and ypos > 154 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.fernseher1,l10n.fernseher2,l10n.fernseher3);
			end
			
			if xpos > 245 and xpos < 294 and ypos > 110 and ypos < 116 then
				ypos = 116
			end

			if xpos > 291 and xpos < 294 and ypos > 100 and ypos < 116 then
				xpos = 294
			end

			if xpos > 211 and xpos < 245 and ypos > 154 and ypos < 157 then
				ypos = 157
			end

			if xpos > 211 and xpos < 216 and ypos > 102 and ypos < 157 then
				xpos = 211
			end

			if xpos > 211 and xpos < 245 and ypos > 102 and ypos < 107 then
				ypos = 102
			end

			if xpos > 242 and xpos < 245 and ypos > 102 and ypos < 157 then
				xpos = 245
			end

			if xpos > 159 and xpos < 185 and ypos > 140 and ypos < 142 then
				ypos = 142
			end

			if xpos > 159 and xpos < 185 and ypos > 150 and ypos < 154 then
				ypos = 150
			end

			if xpos > 182 and xpos < 185 and ypos > 119 and ypos < 142 then
				xpos = 185
			end

			if xpos > 182 and xpos < 185 and ypos > 150 and ypos < 163 then
				xpos = 185
			end

			-- Piso 1
			if xpos < 299 and xpos > 290 and ypos > 50 and ypos < 100 then
				xpos = 283
				ypos = 90
				zone = casa
			
			end

			if xpos > 162 and xpos < 182 and ypos > 141 and ypos < 171 and mypokemon and pge.controls.pressed(PGE_CTRL_CROSS) then
				hp_restore();
			end

		end
		
		if zone == casa2 then
			
			
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			zonex = 152
			zoney = 69.5
			drawsmap(casa2,zonex,zoney);
			
			drawsmap(seller,305,90)
		 
			drawhero();
			animatehero();
			
			endMainFunctions();
			
			-- Go to Zone1
			if xpos > 205 and xpos < 220 and ypos > 177 then
				xpos = 400
				ypos = 227
				zone = 1
				pge.mp3.stop()
			   pge.mp3.play("Content/SFX/hometown.mp3")
			end
			
			if xpos > 286 and ypos > 98 and ypos < 100 then
				ypos = 100
			end
			
			if xpos > 285 and ypos < 99 then
				xpos = 285
			end
			
			if xpos > 298 and ypos <= 100 and pge.controls.pressed(PGE_CTRL_CROSS) then
				business()
			end

			if xpos <= 205 and ypos > 173 then
				ypos = 173
			end

			if xpos >= 160 and xpos < 165 and ypos > 145 and ypos < 180 then
				xpos = 165
			end

			if xpos < 165 and ypos > 145 and ypos <= 160 then
				ypos = 145
			end

			if xpos < 150 and ypos > 90 and ypos < 147 then
				xpos = 150
			end

			if xpos > 145 and xpos < 210 and ypos >= 60 and ypos < 94 then
				ypos = 94
			end

			if xpos > 210 and xpos < 212 and ypos > 83 and ypos < 94 then
				xpos = 212
			end

			if xpos > 209 and xpos < 217 and ypos < 88 then
				ypos = 88
			end

			if xpos > 210 and xpos < 212 and ypos > 83 and ypos < 94 then
				xpos = 212
			end
			
			if xpos > 210 and xpos <= 212 and ypos > 83 and ypos < 94 and pge.controls.pressed(PGE_CTRL_CROSS) then
				lixo();
			end
			
			if xpos > 212 and xpos < 214 and ypos > 83 and ypos < 94 then
				xpos = 212
			end

			if xpos > 215 and xpos < 245 and ypos > 70 and ypos < 94 then
				ypos = 94
			end
			
			if xpos > 245 and xpos < 247 and ypos > 83 and ypos < 94 then
				xpos = 247
			end

			if xpos > 244 and xpos < 320 and ypos > 70 and ypos < 88 then
				ypos = 88
			end
			
			if xpos > 255 and xpos < 267 and ypos >= 88 and pge.controls.pressed(PGE_CTRL_CROSS) then
				talk(l10n.map1, l10n.map2, l10n.map3, l10n.map4);
			end

			if xpos > 308 and xpos < 320 and ypos < 160 and ypos > 87 then
				xpos = 308
			end

			if xpos > 291 and ypos > 145 and ypos < 147 then
				ypos = 145
			end

			if xpos > 291 and xpos < 320 and ypos < 178 and ypos > 145 then
				xpos = 291
			end

			if xpos > 219 and xpos < 295 and ypos > 173 and ypos <= 190 then
				ypos = 173
			end

			if xpos > 195 and xpos < 279 and ypos > 150 and ypos < 155 then
				ypos = 155
			end

			if xpos > 195 and xpos < 200 and ypos < 155 and ypos > 111 then
				xpos = 195
			end

			if xpos > 195 and xpos < 279 and ypos > 111 and ypos < 120 then
				ypos = 111
			end

			if xpos > 270 and xpos < 279 and ypos < 155 and ypos > 111 then
				xpos = 279
			end

		end
		
		if zone == lab then
			
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			zonex = 133.5
			zoney = 31
			drawsmap(lab,zonex,zoney);
			drawsmap(oak, 225, 85);
			
			drawhero();
			animatehero();
			
			endMainFunctions();
			
			-- Go to Zone2
			if xpos > 218 and xpos < 234 and ypos > 215 then
				xpos = 277.5
				ypos = 104
				zone = 2
				
			end
			
			if xpos > 240 and xpos < 309 and ypos < 110 and ypos > 108 then
				ypos = 110
			end
			
			-- Choose pokemon
			if xpos > 255 and xpos < 292 and ypos > 108 and ypos <= 110 and pge.controls.pressed(PGE_CTRL_CROSS) then
				
				if not mypokemon then
					getpokemon();
				end
				
			end
			
			if xpos > 140 and xpos < 218 and ypos > 214 then
				ypos = 214
			end
			
			if xpos <= 147 and xpos > 140 and ypos > 186 and ypos < 218 then
				xpos = 147
			end
			
			if xpos > 111 and xpos < 147 and ypos > 186 and ypos < 200 then
				ypos = 186
			end
			
			if xpos < 132 and xpos > 120 and ypos < 190 and ypos > 160 then
				xpos = 132
			end
			
			if xpos > 130 and xpos < 213 and ypos > 160 and ypos < 166 then
				ypos = 166
			end
			
			if xpos < 213 and xpos > 205 and ypos < 166 and ypos > 126 then
				xpos = 213
			end
			
			if xpos > 120 and xpos < 213 and ypos > 126 and ypos < 132 then
				ypos = 126
			end
			
			if xpos < 130 and xpos > 120 and ypos < 134 and ypos > 101 then
				xpos = 130
			end
			
			if xpos > 128 and xpos < 133 and ypos > 98 and ypos < 103 then
				ypos = 103
			end
			
			if xpos < 135 and xpos > 130 and ypos < 113 and ypos > 101 then
				xpos = 130
			end
			
			if xpos > 130 and xpos < 182 and ypos > 111 and ypos < 113 then
				ypos = 113
			end
			
			if xpos < 182 and xpos > 180 and ypos < 113 and ypos > 63 then
				xpos = 182
			end
			
			if xpos > 140 and xpos < 182 and ypos > 63 and ypos < 65 then
				ypos = 63
			end
			
			if xpos < 144 and xpos > 142 and ypos < 65 and ypos > 54 then
				xpos = 144
			end
			
			if xpos > 127 and xpos < 144 and ypos > 54 and ypos < 57 then
				ypos = 54
			end
			
			if xpos < 130 and xpos > 126 and ypos < 56 and ypos > 50 then
				xpos = 130
			end
			
			if xpos > 125 and xpos < 228 and ypos > 49 and ypos < 52 then
				ypos = 52
			end
			
			if xpos < 228 and xpos > 220 and ypos < 52 and ypos > 30 then
				xpos = 228
			end
			
			if xpos > 226 and xpos < 259 and ypos > 40 and ypos < 45 then
				ypos = 45
			end
			
			if xpos < 258 and xpos > 256 and ypos < 52 and ypos > 30 then
				xpos = 256
			end
			
			if xpos > 256 and xpos < 326 and ypos > 44 and ypos < 52 then
				ypos = 52
			end
			
			if xpos < 325 and xpos > 320 and ypos < 130 and ypos > 50 then
				xpos = 320
			end
			
			if xpos > 240 and xpos < 325 and ypos > 126 and ypos < 132 then
				ypos = 126
			end
			
			if xpos < 245 and xpos > 240 and ypos < 166 and ypos > 126 then
				xpos = 240
			end
			
			if xpos > 240 and xpos < 325 and ypos > 160 and ypos < 166 then
				ypos = 166
			end
			
			if xpos < 324 and xpos > 320 and ypos < 190 and ypos > 160 then
				xpos = 320
			end
			
			if xpos > 305 and xpos < 323 and ypos > 186 and ypos < 190 then
				ypos = 186
			end
			
			if xpos < 310 and xpos > 305 and ypos < 220 and ypos > 186 then
				xpos = 305
			end
			
			if xpos > 234 and xpos < 308 and ypos > 214 and ypos < 217 then
				ypos = 214
			end
			
			if xpos < 245 and xpos > 240 and ypos < 110 and ypos > 72 then
				xpos = 240
			end
			
			if xpos > 240 and xpos < 310 and ypos > 72 and ypos < 75 then
				ypos = 72
			end
			
			if xpos < 310 and xpos > 306 and ypos < 110 and ypos > 72 then
				xpos = 310
			end
			
			-- Oak
			if xpos > 204 and xpos < 238 and ypos > 93 and ypos < 95 then
				ypos = 95
			end
			
			if xpos < 208 and xpos > 204 and ypos < 95 and ypos > 62 then
				xpos = 204
			end
			
			if xpos > 204 and xpos < 238 and ypos > 62 and ypos < 65 then
				ypos = 62
			end
			
			if xpos < 238 and xpos > 234 and ypos < 95 and ypos > 62 then
				xpos = 238
			end
			
			if xpos > 216 and xpos < 229 and ypos > 70 and ypos <= 95 and pge.controls.pressed(PGE_CTRL_CROSS) then
				
				if mypokemon then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						drawsmap(dialog,120, 71);
						trebuc16:activate();
						trebuc16:printcenter(81, white, l10n.oakmsg1 .. mypoke.name .. l10n.oakmsg2)
						trebuc12:activate();
						trebuc12:printcenter(125, white, l10n.oakmsg3)
						trebuc12:printcenter(140, white, l10n.oakmsg4)
						endMainFunctions();
						if pge.controls.pressed(PGE_CTRL_CIRCLE) then
							break
						end
					end
				else
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						drawsmap(dialog,120, 71);
						trebuc16:activate();
						trebuc16:printcenter(81, white, l10n.oakmsg5)
						trebuc12:activate();
						trebuc12:printcenter(110, white, l10n.oakmsg6)
						trebuc12:printcenter(125, white, l10n.oakmsg7)
						trebuc12:printcenter(140, white, l10n.oakmsg8)
						trebuc12:printcenter(155, white, l10n.oakmsg9)
						trebuc12:printcenter(170, white, l10n.oakmsg10)
						trebuc12:printcenter(185, white, l10n.oakmsg11)
						endMainFunctions();
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
					end
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						drawsmap(dialog,120, 71);
						trebuc16:activate();
						trebuc16:printcenter(81, white, l10n.oakmsg5)
						trebuc12:activate();
						trebuc12:printcenter(125, white, l10n.oakmsg12)
						trebuc12:printcenter(140, white, l10n.oakmsg13)
						if pge.controls.pressed(PGE_CTRL_CIRCLE) then
							break
						end
						endMainFunctions();
					end
				end
			end
			
		end
		
		if zone == gym then
			
			pge.controls.update()
			pge.gfx.startdrawing()
			pge.gfx.clearscreen()
			zonex = 120			
			zoney = 9.5
			drawsmap(gym,zonex,zoney);
			
			if trainer[0].direction == "down" then
				drawsmap(trainer0,trainer[0].x,trainer[0].y)
			elseif trainer[0].direction == "right" then
				drawsmap(trainer0_r,trainer[0].x,trainer[0].y)
			elseif trainer[0].direction == "left" then
				drawsmap(trainer0_l,trainer[0].x,trainer[0].y)
			end
			trainer[0].direction = "down"
		 
			drawhero();
			animatehero();
			
			-- Go to Zone2
			if xpos > 221 and xpos < 233 and ypos > 230 then
				xpos = 84.5
				ypos = 104
				zone = 2
			
			end
			
			if xpos > trainer[0].x-SPRITEDIM+5 and xpos < trainer[0].x+SPRITEDIM-5 and ypos > trainer[0].y+SPRITEDIM-16 and ypos < trainer[0].y+SPRITEDIM-14 then
				ypos = trainer[0].y+SPRITEDIM-14
				trainer[0].direction = "down"
			end
			
			if xpos >= trainer[0].x-SPRITEDIM+4 and xpos < trainer[0].x and ypos > trainer[0].y-SPRITEDIM+5 and ypos < trainer[0].y+SPRITEDIM-15 then
				xpos = trainer[0].x-SPRITEDIM+4
				trainer[0].direction = "left"
			end
			
			if xpos > trainer[0].x-SPRITEDIM+5 and xpos < trainer[0].x+SPRITEDIM-5 and ypos > trainer[0].y-SPRITEDIM+2 and ypos < trainer[0].y-SPRITEDIM+4 then
				ypos = trainer[0].y-SPRITEDIM+2
				trainer[0].direction = "up"
			end
			
			if xpos > trainer[0].x+SPRITEDIM-6 and xpos <= trainer[0].x+SPRITEDIM-4 and ypos > trainer[0].y-SPRITEDIM+5 and ypos < trainer[0].y+SPRITEDIM-15 then
				xpos = trainer[0].x+SPRITEDIM-4
				trainer[0].direction = "right"
			end
			
			if xpos <= 221 and ypos > 228 then
				ypos = 228
			end
			
			if xpos >= 233 and ypos > 228 then
				ypos = 228
			end
			
			if xpos < 150 and zone ~= 2 then
				xpos = 150
			end
			
			if xpos > 308 then
				xpos = 308
			end
			
			if ypos < 50 then
				ypos = 50
			end
			
			if xpos > 180 and xpos < 214 and ypos < 206 and ypos > 202 then
				ypos = 206
			end

			if xpos >242 and xpos < 278 and ypos < 206 and ypos > 202 then
				ypos = 206
			end
			
			if xpos >180 and xpos < 214 and ypos < 200 and ypos > 164 then
				ypos = 164
			end

			if xpos > 242 and xpos < 278 and ypos < 200 and ypos > 164 then
				ypos = 164
			end
			
			if xpos >178 and xpos < 200 and ypos > 164 and ypos < 206 then
				xpos = 178
			end
			
			if xpos > 240 and xpos < 250 and ypos > 164 and ypos < 206 then
				xpos = 240
			end
			
			if xpos > 200 and xpos < 216 and ypos > 164 and ypos < 206 then
				xpos = 216
			end
			
			if xpos > 250 and xpos < 280 and ypos > 164 and ypos < 206 then
				xpos = 280
			end
			
			if ypos <= trainer[0].y+SPRITEDIM-14 and xpos >= trainer[0].x-SPRITEDIM+4 and ypos >= trainer[0].y-SPRITEDIM+2 and xpos <= trainer[0].x+SPRITEDIM-4 and pge.controls.pressed(PGE_CTRL_CROSS) then
				if mypoke.xpr >= 50 and victories >= 2 then
					talk(l10n.leaderyes1, l10n.leaderyes2,"");
					tid = 0
					pzone = zone
					zone = trainerbattle
				else
					talk(l10n.leaderno1, l10n.leaderno2, l10n.leaderno3);
				end
			end
			
			endMainFunctions();
			
		end
		
		if zone == battle then
		menuSlt = 0
		counter = 1
		battleintro = pge.gfx.createcolor(0, 0, 0, 255)
		introalpha = 255
		evolution();
		joker = pge.math.randint(1,joker_t+1)
		mypoke.defr = mypoke.def
		enemy[joker].lvl = pge.math.randint(subirnivel() - 1,enemy[joker].lvl)
		
		pge.mp3.play("Content/SFX/battle1.mp3")
		
		while pge.running() do
			
			if introalpha <= 0 then
				pge.controls.update()
			end
			pge.gfx.startdrawing()
			pge.gfx.clearscreen(black)
			
			
			
			
			drawmap(battle3);
			
			
			-- Intro
			introalpha = pge.gfx.alpha(battleintro)
			pge.gfx.alpha(battleintro, introalpha - 1)
			
			-- Pokemons
			mypoke.x = 40
			mypoke.y = 135
			enemy[joker].x = 325
			enemy[joker].y = 10
		
			drawsmap(mypoke.back,mypoke.x,mypoke.y)
			drawsmap(enemy[joker].front,enemy[joker].x,enemy[joker].y)
			
			-- My pokemon
			_print(trebuc12,165,192,black,l10n.texthp..mypoke.hpr)
			pge.gfx.drawrect(165,181, calchp(mypoke), 5, colorhp(mypoke))
			pge.gfx.drawrectoutline(165, 181, 60, 5, black)
			_print(trebuc12,165,167,black,l10n.textlvl..subirnivel())
			_print(trebuc12,165,152,blue,mypoke.name)
			
			-- Enemy
			_print(trebuc12,210,20,red,enemy[joker].name)
			_print(trebuc12,210,35,black,l10n.textlvl..enemy[joker].lvl)
			pge.gfx.drawrect(210,49, calchp(enemy[joker]), 5, colorhp(enemy[joker]))
			pge.gfx.drawrectoutline(210, 49, 60, 5, black)
			
			if counter == 0 then
				if damage and movetype == "attack" then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.drawrect(5, 210, 475, 55, black)
						_print(trebuc12,60,235,white,l10n.textlostx1..enemy[joker].name..l10n.textlostx2..pdamage..l10n.textlostx3) 
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
						endMainFunctions();
					end
				elseif movetype == "defense" then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.drawrect(5, 210, 475, 55, black)
						_print(trebuc12,60,235,white,l10n.textdef1..mypoke.name..l10n.textdef2) 
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
						endMainFunctions();
					end
				elseif itensuse == 1 then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.drawrect(5, 210, 475, 55, black)
						_print(trebuc12,60,235,white,l10n.potionuse)
						itensuse = 0
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
						endMainFunctions();
					end
				end
				enemy_damage_calc();
				counter = 1
			elseif counter == 1 then
				if damage then
					pge.gfx.drawrect(5, 212, 296, 51, black)
					_print(trebuc12,60,235,white,l10n.textlosty1..mypoke.name..l10n.textlosty2..pdamage..l10n.textlosty3) 
				end
					
				if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_RIGHT) then
					menuSelector = 1
				elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_LEFT) then
					menuSelector = 1
				elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_RIGHT) then
					menuSelector = 0
				elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_LEFT) then
					menuSelector = 0
				elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_DOWN) then
					menuSelector = 2
				elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_UP) then
					menuSelector = 2
				elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_UP) then
					menuSelector = 0
				elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_DOWN) then
					menuSelector = 0
				end
				
				-- Menu
				if menuSelector == 0 then
					_print(trebuc12,330,222,red,l10n.battleopt1)
					_print(trebuc12,420,222,white,l10n.battleopt2)
					_print(trebuc12,330,242,white,l10n.battleopt3)
				elseif menuSelector == 1 then
					_print(trebuc12,330,222,white,l10n.battleopt1)
					_print(trebuc12,420,222,blue,l10n.battleopt2)
					_print(trebuc12,330,242,white,l10n.battleopt3)
				elseif menuSelector == 2 then
					_print(trebuc12,330,222,white,l10n.battleopt1)
					_print(trebuc12,420,222,white,l10n.battleopt2)
					_print(trebuc12,330,242,green,l10n.battleopt3)
				end
				
				if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.drawrect(5, 212, 296, 51, black)
						drawsmap(battle2,5,211)
					 
						if pge.controls.pressed(PGE_CTRL_LEFT) then
							menuSlt = menuSlt - 1
						elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
							menuSlt = menuSlt + 1
						elseif pge.controls.pressed(PGE_CTRL_UP) then
							menuSlt = menuSlt - 2
						elseif pge.controls.pressed(PGE_CTRL_DOWN) then
							menuSlt = menuSlt + 2
						end
						
						if menuSlt >= 4 then
							menuSlt = 0
						elseif menuSlt < 0 then
							menuSlt = 3
						end
						
						if menuSlt == 0 then
							_print(trebuc12,60,222,red,mypoke.atk1) 
							_print(trebuc12,150,222,white,mypoke.atk2)
							_print(trebuc12,60,242,white,getattack3())
							_print(trebuc12,150,242,white,getattack4())
						elseif menuSlt == 1 then
							_print(trebuc12,60,222,white,mypoke.atk1) 
							_print(trebuc12,150,222,blue,mypoke.atk2)
							_print(trebuc12,60,242,white,getattack3())
							_print(trebuc12,150,242,white,getattack4())
						elseif menuSlt == 2 then
							_print(trebuc12,60,222,white,mypoke.atk1) 
							_print(trebuc12,150,222,white,mypoke.atk2)
							_print(trebuc12,60,242,red,getattack3())
							_print(trebuc12,150,242,white,getattack4())
						elseif menuSlt == 3 then
							_print(trebuc12,60,222,white,mypoke.atk1) 
							_print(trebuc12,150,222,white,mypoke.atk2)
							_print(trebuc12,60,242,white,getattack3())
							_print(trebuc12,150,242,green,getattack4())
						end
						
						if menuSlt == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
							-- ATK1
							damage_calc("a", enemy[joker])
							counter = 2
							break
						elseif menuSlt == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
							-- ATK2
							damage_calc("d", enemy[joker])
							counter = 2
							break
						elseif menuSlt == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
							-- ATK3
							if getattack3() == "--" then
							-- NADA
							else
							damage_calc("a", enemy[joker])
							counter = 2
							break
							end
						elseif menuSlt == 3 and pge.controls.pressed(PGE_CTRL_CROSS) then
							-- ATK4
							if getattack4() == "--" then
								-- NADA
							else
								 damage_calc("d", enemy[joker])
								 counter = 2
								 break
							end
						end
						
						endMainFunctions();
						
						if pge.controls.pressed(PGE_CTRL_CIRCLE) then
							break
						end
						
					 end
				elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.drawrect(5, 212, 296, 51, black)
						_print(trebuc12,60,235,white,l10n.runmsg)
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
						endMainFunctions();
					end
					enemy[joker].hpr = enemy[joker].hp
					pge.mp3.play("Content/SFX/hometown.mp3")
					segundos = pge.timer.create()
					zone = pzone
					break
				elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
					usepotion();
				end
			elseif counter == 2 then
				damage = 0
				counter = 0
			--[[  0: Messages / Enemy attack
					1: Player Turn
					2: Clean-up ]]--
			end
			
			-- End of Battle
			if enemy[joker].hpr <= 0 then
				pge.mp3.stop()
				pge.mp3.play("Content/SFX/victory.mp3")
				battlexp = pge.math.ceil(((enemy[joker].hp / mypoke.hp) * subirnivel()) * 5)
				while pge.running() do
					pge.controls.update()
					pge.gfx.startdrawing()
					pge.gfx.clearscreen()
					drawsmap(dialog,120, 71);
					trebuc16:activate();
					trebuc16:printcenter(81, white, l10n.wonmsg1..enemy[joker].name)
					trebuc16:printcenter(100, white, l10n.wonmsg2)
					trebuc12:activate();
					trebuc12:printcenter(140, white, l10n.wonmsg3..battlexp..l10n.wonmsg4)
					trebuc12:printcenter(170, white, l10n.continue)
					if pge.controls.pressed(PGE_CTRL_CROSS) then
						pge.mp3.stop()
						break
					end
					endMainFunctions();
				end
				enemy[joker].hpr = enemy[joker].hp
				mypoke.xpr = mypoke.xpr + battlexp
				pge.mp3.play("Content/SFX/hometown.mp3")
				segundos = pge.timer.create()
				zone = pzone
				break
			end
			
			if mypoke.hpr <= 0 then
				while pge.running() do
					pge.controls.update()
					pge.gfx.startdrawing()
					pge.gfx.clearscreen()
					drawsmap(dialog,120, 71);
					trebuc16:activate();
					trebuc16:printcenter(81, white, l10n.lostmsg1)
					trebuc16:printcenter(100, white, enemy[joker].name..l10n.lostmsg2)
					trebuc12:activate();
					trebuc12:printcenter(150, white, l10n.continue)
					if pge.controls.pressed(PGE_CTRL_CROSS) then
						break
					end
					endMainFunctions();
				end
				mypoke.hpr = mypoke.hp
				enemy[joker].hpr = enemy[joker].hp
				pge.mp3.play("Content/SFX/hometown.mp3")
				xpos = 164
				ypos = 149
				zone = casa1
				break
			end
			
			-- Intro
			if introalpha > 0 then
				menuSelector = 0
				pge.gfx.drawrect(5, 212, 296, 51, black)
				_print(trebuc12,60,235,white,l10n.found1..enemy[joker].name..l10n.found2)
				pge.gfx.drawrect(0, 0, 480, 272, battleintro)
			end
			
			endMainFunctions();
		 
		end
		
		menuSelector = nil
		menuSlt = nil
		counter = nil
		damage = nil
		end
		
		if zone == trainerbattle then
			menuSlt = 0
			counter = 1
			battleintro = pge.gfx.createcolor(0, 0, 0, 255)
			introalpha = 255
			i = 0
			j = 0
			n = 1
			p = 1
         evolution();
			id = tid
			mypoke.defr = mypoke.def
			
			pge.mp3.play("Content/SFX/battle2.mp3")
			
			while pge.running() do
			
				pge.gfx.startdrawing()
				pge.gfx.clearscreen(black)
				drawmap(battle);
				
				-- Intro
				introalpha = pge.gfx.alpha(battleintro)
				pge.gfx.alpha(battleintro, introalpha - 1)
				
				pge.gfx.drawrect(200, 10, 280, 104, white)
				drawsmap(trainer[id].front,315,10)
				
				if introalpha > 0 then
					menuSelector = 0
					
					pge.gfx.drawrect(5, 210, 475, 55, black)
					_print(trebuc12,60,235,white,l10n.fighting..trainer[id].subject.." "..trainer[id].name..".")
					drawsmap(ash_back,40,96)
					pge.gfx.drawrect(0, 0, 480, 272, battleintro)
				else
					i = i+1
					pge.gfx.drawrect(5, 210, 475, 55, black)
					_print(trebuc12,60,235,white,l10n.textgo..mypoke.name.."!")
					if i < 30 and j == 0 then
						drawsmap(ash_back,40,96)
					elseif i >= 30 and j == 0 then
						drawsmap(ash_back,40,96)
						j = 1
					elseif i >= 30 and j == 1 then
						pge.delay(0200000)
						drawsmap(ash_back,40,96)
						pge.delay(0200000)
						break
					end
				end
				
				endMainFunctions();
			
			end
			
			while pge.running() do
			
				if j > 30 then
					j = 31
					pge.controls.update()
				end
				j = j +1
				
				pge.gfx.startdrawing()
				pge.gfx.clearscreen(black)
				drawmap(battle);
				
				-- Pokemons
				mypoke.x = 40
				mypoke.y = 135
				trainer[id].poke[n].x = 325
				trainer[id].poke[n].y = 10
				
				drawsmap(mypoke.back,mypoke.x,mypoke.y)
				drawsmap(trainer[id].poke[n].front,trainer[id].poke[n].x,trainer[id].poke[n].y)
				
				-- My pokemon
				_print(trebuc12,165,192,black,l10n.texthp..mypoke.hpr)
				pge.gfx.drawrect(165,181, calchp(mypoke), 5, colorhp(mypoke))
				pge.gfx.drawrectoutline(165, 181, 60, 5, black)
				_print(trebuc12,165,167,black,l10n.textlvl..subirnivel())
				_print(trebuc12,165,152,blue,mypoke.name)
				
				-- Enemy
				_print(trebuc12,210,20,red,trainer[id].poke[n].name)
				_print(trebuc12,210,35,black,l10n.textlvl..trainer[id].poke[n].lvl)
				pge.gfx.drawrect(210,49, calchp(trainer[id].poke[n]), 5, colorhp(trainer[id].poke[n]))
				pge.gfx.drawrectoutline(210, 49, 60, 5, black)
				
				if counter == 0 then
					if damage and movetype == "attack" then
						while pge.running() do
							pge.controls.update()
							pge.gfx.startdrawing()
							pge.gfx.drawrect(5, 210, 475, 55, black)
							_print(trebuc12,60,235,white,l10n.textlostx0..trainer[id].poke[n].name..l10n.textlostx4..pdamage..l10n.textlostx3) 
							if pge.controls.pressed(PGE_CTRL_CROSS) then
								break
							end
							endMainFunctions();
						end
					elseif movetype == "defense" then
						while pge.running() do
							pge.controls.update()
							pge.gfx.startdrawing()
							pge.gfx.drawrect(5, 210, 475, 55, black)
							_print(trebuc12,60,235,white,l10n.textdef1..mypoke.name..l10n.textdef2) 
							if pge.controls.pressed(PGE_CTRL_CROSS) then
								break
							end
							endMainFunctions();
						end
					elseif itensuse == 1 then
						while pge.running() do
							pge.controls.update()
							pge.gfx.startdrawing()
							pge.gfx.drawrect(5, 210, 475, 55, black)
							_print(trebuc12,60,235,white,l10n.potionuse)
							itensuse = 0
							if pge.controls.pressed(PGE_CTRL_CROSS) then
								break
							end
							endMainFunctions();
						end
					end
					enemy_damage_calc();
					counter = 1
				elseif counter == 1 then
					if damage then
						pge.gfx.drawrect(5, 212, 296, 51, black)
						_print(trebuc12,60,235,white,l10n.textlosty1..mypoke.name..l10n.textlosty2..pdamage..l10n.textlosty3) 
					end

					if limbo ~= nil then
						anim_die()
						pge.gfx.drawrect(5, 212, 296, 51, black)
						_print(trebuc12,60,235,white,l10n.pokekill)
					end
						
					if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_RIGHT) then
						menuSelector = 1
					elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_LEFT) then
						menuSelector = 1
					elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_RIGHT) then
						menuSelector = 0
					elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_LEFT) then
						menuSelector = 0
					elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_DOWN) then
						menuSelector = 2
					elseif menuSelector == 0 and pge.controls.pressed(PGE_CTRL_UP) then
						menuSelector = 2
					elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_UP) then
						menuSelector = 0
					elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_DOWN) then
						menuSelector = 0
					end
					
					-- Menu
					if menuSelector == 0 then
						_print(trebuc12,330,222,red,l10n.battleopt1)
						_print(trebuc12,420,222,white,l10n.battleopt2)
						_print(trebuc12,330,242,white,l10n.battleopt3)
					elseif menuSelector == 1 then
						_print(trebuc12,330,222,white,l10n.battleopt1)
						_print(trebuc12,420,222,blue,l10n.battleopt2)
						_print(trebuc12,330,242,white,l10n.battleopt3)
					elseif menuSelector == 2 then
						_print(trebuc12,330,222,white,l10n.battleopt1)
						_print(trebuc12,420,222,white,l10n.battleopt2)
						_print(trebuc12,330,242,green,l10n.battleopt3)
					end
					
					if menuSelector == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
						while pge.running() do
							pge.controls.update()
							pge.gfx.startdrawing()
							pge.gfx.drawrect(5, 212, 296, 51, black)
							drawsmap(battle2,5,211)
						 
							if pge.controls.pressed(PGE_CTRL_LEFT) then
								menuSlt = menuSlt - 1
							elseif pge.controls.pressed(PGE_CTRL_RIGHT) then
								menuSlt = menuSlt + 1
							elseif pge.controls.pressed(PGE_CTRL_UP) then
								menuSlt = menuSlt - 2
							elseif pge.controls.pressed(PGE_CTRL_DOWN) then
								menuSlt = menuSlt + 2
							end
							
							if menuSlt >= 4 then
								menuSlt = 0
							elseif menuSlt < 0 then
								menuSlt = 3
							end
							
							if menuSlt == 0 then
								_print(trebuc12,60,222,red,mypoke.atk1) 
								_print(trebuc12,150,222,white,mypoke.atk2)
								_print(trebuc12,60,242,white,getattack3())
								_print(trebuc12,150,242,white,getattack4())
							elseif menuSlt == 1 then
								_print(trebuc12,60,222,white,mypoke.atk1) 
								_print(trebuc12,150,222,blue,mypoke.atk2)
								_print(trebuc12,60,242,white,getattack3())
								_print(trebuc12,150,242,white,getattack4())
							elseif menuSlt == 2 then
								_print(trebuc12,60,222,white,mypoke.atk1) 
								_print(trebuc12,150,222,white,mypoke.atk2)
								_print(trebuc12,60,242,red,getattack3())
								_print(trebuc12,150,242,white,getattack4())
							elseif menuSlt == 3 then
								_print(trebuc12,60,222,white,mypoke.atk1) 
								_print(trebuc12,150,222,white,mypoke.atk2)
								_print(trebuc12,60,242,white,getattack3())
								_print(trebuc12,150,242,green,getattack4())
							end
							
							if menuSlt == 0 and pge.controls.pressed(PGE_CTRL_CROSS) then
								-- ATK1
								damage_calc("a", trainer[id].poke[n])
								counter = 2
								break
							elseif menuSlt == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
								-- ATK2
								damage_calc("d", trainer[id].poke[n])
								counter = 2
								break
							elseif menuSlt == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
								-- ATK3
								if getattack3() == "--" then
								-- NADA
								else
								 damage_calc("a", trainer[id].poke[n])
								 counter = 2
								 break
								end
							elseif menuSlt == 3 and pge.controls.pressed(PGE_CTRL_CROSS) then
								-- ATK4
								if getattack4() == "--" then
								-- NADA
								else
								 damage_calc("d", trainer[id].poke[n])
								 counter = 2
								 break
								end
							end
							
							endMainFunctions();
							
							if pge.controls.pressed(PGE_CTRL_CIRCLE) then
								break
							end
							
						 end
					elseif menuSelector == 1 and pge.controls.pressed(PGE_CTRL_CROSS) then
						while pge.running() do
							pge.controls.update()
							pge.gfx.startdrawing()
							pge.gfx.drawrect(5, 212, 296, 51, black)
							_print(trebuc12,60,235,white,l10n.runmsgno)
							if pge.controls.pressed(PGE_CTRL_CROSS) then
								break
							end
							endMainFunctions();
						end
					elseif menuSelector == 2 and pge.controls.pressed(PGE_CTRL_CROSS) then
						usepotion();
					end
				elseif counter == 2 then
					damage = 0
					counter = 0
				--[[  0: Messages / Enemy attack
						1: Player Turn
						2: Clean-up ]]--
				end
				
				-- End of Battle
				if trainer[id].poke[trainer[id].npoke].hpr <= 0 then
					pge.mp3.stop()
					if id == 0 then pge.mp3.play("Content/SFX/victorygym.mp3") else pge.mp3.play("Content/SFX/victorytrainer.mp3") end
					battlexp = pge.math.abs(pge.math.ceil((trainer[id].poke[n].hp / mypoke.hp - (mypoke.defr * 0.5)) * subirnivel()) * trainer[id].npoke * 2)
					moneywon = pge.math.ceil(battlexp * trainer[id].poke[n].hp * (trainer[id].poke[n].lvl / 2.5))
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.clearscreen()
						drawsmap(dialog,120, 71);
						trebuc16:activate();
						trebuc16:printcenter(81, white, l10n.wonmsg0.." "..trainer[id].subject)
						trebuc16:printcenter(100, white,trainer[id].name.."!")
						trebuc12:activate();
						trebuc12:printcenter(140, white, l10n.wonmsg3..battlexp..l10n.wonmsg5.." $"..moneywon..".")
						trebuc12:printcenter(170, white, l10n.continue)
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							pge.mp3.stop()
							break
						end
						endMainFunctions();
					end
					while p <= trainer[id].npoke do
						trainer[id].poke[p].hpr = trainer[id].poke[p].hp
						p = p + 1
					end
					mypoke.xpr = mypoke.xpr + battlexp
					itens.money = itens.money + moneywon
					victories = victories + 1
					pge.mp3.play("Content/SFX/hometown.mp3")
					zone = pzone
					break
				elseif trainer[id].poke[n].hpr <= 0 and counter == 0 then
					--anim_die()
					n = n + 1
					limbo = 1
					counter = 1
				end
				
				if mypoke.hpr <= 0 then
				moneylost = pge.math.ceil(pge.math.randint(itens.money*0.3,itens.money*0.5))
					while pge.running() do
						pge.controls.update()
						pge.gfx.startdrawing()
						pge.gfx.clearscreen()
						drawsmap(dialog,120, 71);
						trebuc16:activate();
						trebuc16:printcenter(81, white, l10n.lostmsg0..trainer[id].subject)
						trebuc16:printcenter(100, white, trainer[id].name..l10n.lostmsg2)
						trebuc12:activate();
						trebuc12:printcenter(140, white, l10n.lostmoney.." $"..moneylost..".")
						trebuc12:printcenter(170, white, l10n.continue)
						if pge.controls.pressed(PGE_CTRL_CROSS) then
							break
						end
						endMainFunctions();
					end
					mypoke.hpr = mypoke.hp
					while p <= trainer[id].npoke do
						trainer[id].poke[p].hpr = trainer[id].poke[p].hp
						p = p + 1
					end
					itens.money = itens.money - moneylost
					if itens.money < 0 then
						itens.money = 0
					end
					pge.mp3.play("Content/SFX/hometown.mp3")
					xpos = 164
					ypos = 149
					zone = casa1
					break
				end
				
				endMainFunctions();
			 
			end
			
			menuSelector = nil
			menuSlt = nil
			counter = nil
			damage = nil
			i = nil
			j = nil
			p = nil
		end
		
		if xpos < 0 then
			xpos = 0
		end
		
		if xpos > 480 - SPRITEDIM then
			xpos = 480 - SPRITEDIM 
		end
		
		if ypos < 0 then
			ypos = 0
		end
		
		if ypos > 272 - SPRITEDIM then
			ypos = 272 - SPRITEDIM 
		end
	 
		-- If SQUARE held, walk faster
		if pge.controls.held(PGE_CTRL_SQUARE) then
			if zone == 1 or zone == 2 then
				walkspeed = 1.5
			end
		end
		if pge.controls.released(PGE_CTRL_SQUARE) then
			walkspeed = 1.0
		end
		
		-- If START pressed, pause menu
		if pge.controls.pressed(PGE_CTRL_START) and zone ~= battle and zone ~= trainerbattle then
			pausemenu();
		end
		
	end

	zona1 = nil
	zona2 = nil
	casa2 = nil
	lab = nil
	gym = nil
	ash = nil

end

trebuc12 = nil
trebuc16 = nil

pge.usb.deactivate()
pge.usb.shutdown()